import psycopg2
import datetime
count = input("Choose desired reliablity: ")
dev = input("Choose desired max deviation: ")
host = input("Insert host:")
dbname = input("Insert database name:")
user = input("Insert user:")
password = input("Insert password:")
remConn = psycopg2.connect("dbname=" + dbname + " user=" + user + " password=" + password + " host=" + host)
remCur = remConn.cursor()
locConn = psycopg2.connect("dbname=crelip user=crelip")
locCur = locConn.cursor()
#Create a temporary table with relevant successful measure count
remCur.execute("CREATE TEMPORARY TABLE ping_success_count AS(SELECT ip_addr, COUNT(*) as count from ping WHERE ping_ploss >= 0 AND ping_ploss < 100 GROUP BY ip_addr ORDER BY count DESC);")
#Create a temporary table with non-reserved IP addresses
remCur.execute("CREATE TEMPORARY TABLE non_reserved_ip AS(SELECT h.ip_addr AS ip_addr FROM hosts h WHERE NOT (h.ip_addr <<= '0.0.0.0/8' OR h.ip_addr  <<= '0.0.0.0/32' OR h.ip_addr  <<= '10.0.0.0/8' OR h.ip_addr  <<= '100.64.0.0/10' OR h.ip_addr  <<= '127.0.0.0/8' OR h.ip_addr  <<= '169.254.0.0/16' OR h.ip_addr  <<= '172.16.0.0/12' OR h.ip_addr  <<= '192.0.2.0/24' OR h.ip_addr<<= '192.88.99.0/24' OR h.ip_addr  <<= '192.88.99.2/32' OR h.ip_addr <<= '192.168.0.0/16' OR h.ip_addr <<= '192.0.0.0/24' OR h.ip_addr  <<= '198.18.0.0/15' OR h.ip_addr  <<= '198.51.100.0/24' OR h.ip_addr <<= '203.0.113.0/24' OR h.ip_addr <<= '255.255.255.255/32'));")
#Create a table consisting of IP addresses that have at least count successful ping measurements
remCur.execute("CREATE TEMPORARY TABLE good_ip AS(SELECT c.ip_addr, c.count FROM ping_success_count c WHERE c.count >= " + count + " AND c.ip_addr IN (SELECT ip_addr FROM non_reserved_ip));")
#Create a table consisting of average deviations
remCur.execute("CREATE TEMPORARY TABLE deviations AS (SELECT ping_date::date as date, AVG(ping_rttmdev) as dev FROM ping WHERE ping_ploss < 100 AND ping_ploss >= 0 GROUP BY date ORDER BY date);")

remCur.execute("CREATE TEMPORARY TABLE ping_avg_regulated AS(SELECT p.ping_date::date AS date, AVG(p.ping_rttmin) AS ping_rttmin, AVG(p.ping_rttavg) AS ping_rttavg, AVG(p.ping_rttmax) AS ping_rttmax FROM ping p JOIN good_ip g ON p.ip_addr = g.ip_addr JOIN deviations d ON d.date = DATE(p.ping_date) WHERE p.ping_ploss >= 0 AND p.ping_ploss < 100 AND p.ping_date > TO_TIMESTAMP(1230764400) AND g.count >= " + count + " AND d.dev <= " + dev + " GROUP BY p.ping_date::date ORDER BY p.ping_date::date);")
remCur.execute("SELECT * FROM ping_avg_regulated")
for record in remCur:
	locCur.execute("INSERT INTO ping_avg_dev_regulated VALUES(%s, %s, %s, %s);", record)
locConn.commit()
remCur.close()
remConn.close()
locCur.close()
locConn.close()
#ping rucne pre adresu
