import psycopg2
import datetime
from matplotlib import pyplot as plt
import matplotlib.dates as mdates

def fetchData():	
	locConn = psycopg2.connect("dbname=crelip user=crelip")
	locCur = locConn.cursor()
	locCur.execute("SELECT date, ping_rttmin FROM ping_avg_unregulated;")
	ans = locCur.fetchall()
	locCur.close()
	locConn.close()
	return ans
	
def visualizeData(pingData):
	dates, ping_averages = zip(*pingData)
	# Plotting
	plt.figure(figsize=(10, 6))
	plt.plot(dates, ping_averages, marker='o', linestyle='-', color='b')
	plt.title('Ping Averages Over Time')
	plt.xlabel('Date')
	plt.ylabel('Ping Average (ms)')

	# Formatting x-axis with date
	plt.gca().xaxis.set_major_formatter(mdates.DateFormatter('%Y-%m-%d'))
	plt.gca().xaxis.set_major_locator(mdates.YearLocator())
	plt.gcf().autofmt_xdate()
	plt.show()
	
pingData = fetchData()
visualizeData(pingData)
