CREATE PROCEDURE find_gaps()
LANGUAGE plpgsql
AS $$
DECLARE a TIMESTAMP;
	b TIMESTAMP;
	curs CURSOR FOR SELECT date FROM
	(SELECT ping_date AS date FROM ping
	WHERE ping_ploss >= 0 AND ping_ploss < 100
	UNION
	SELECT t_date AS date FROM topology
    	WHERE t_status <> 'E') results
	ORDER BY date ASC;
BEGIN
	DROP TABLE IF EXISTS gaps;
        CREATE TEMP TABLE gaps (gap_begin TIMESTAMP, gap_end TIMESTAMP);   
    OPEN curs;
    FETCH curs INTO a;
    <<read_loop>>
    LOOP
        b := a;
        FETCH curs INTO a;  
        IF NOT FOUND THEN EXIT read_loop;
        END IF;
        IF (SELECT date_part('epoch', a)) - (SELECT date_part('epoch', b)) > 86400 THEN
            INSERT INTO gaps (gap_begin, gap_end)
            VALUES (b,a);
        END IF;
    END LOOP;           
    CLOSE curs;      
END;$$;
