CREATE PROCEDURE find_gaps_topology()
LANGUAGE plpgsql
AS $$
DECLARE a TIMESTAMP;
	b TIMESTAMP;
	curs CURSOR FOR SELECT t_date FROM topology
    	WHERE t_status <> 'E'
	ORDER BY t_date ASC; 
BEGIN        
	DROP TABLE IF EXISTS gaps_topology;
        CREATE TEMP TABLE gaps_topology (gap_begin TIMESTAMP, gap_end TIMESTAMP);   
    OPEN curs;
    FETCH curs INTO a;
    <<read_loop>>
    LOOP
        b := a;
        FETCH curs INTO a;  
        IF NOT FOUND THEN EXIT read_loop;
        END IF;
        IF (SELECT date_part('epoch', a)) - (SELECT date_part('epoch', b)) > 86400 THEN
            INSERT INTO gaps_topology (gap_begin, gap_end)
            VALUES (b,a);
        END IF;
    END LOOP;           
    CLOSE curs;      
END;$$;
