import psycopg2
import datetime
from matplotlib import pyplot as plt
import matplotlib.dates as mdates
host = input("Insert host:")
dbname = input("Insert database name:")
user = input("Insert user:")
password = input("Insert password:")
remConn = psycopg2.connect("dbname=" + dbname + " user=" + user + " password=" + password + " host=" + host)
remCur = remConn.cursor()
locConn = psycopg2.connect("dbname=crelip user=crelip")
locCur = locConn.cursor()
#Zadat nejaku IP adresu, napr.: 223.25.240.2/32
IPAdresa = input("Zadajte IP adresu: ")
#Vybrat vsetky udaje z ping a topology pre danu IP adresu - berieme len z dni, za ktore existuju zaznamy v oboch tabulkach
remCur.execute("""SELECT AVG(p.ping_rttmin) AS ping_min, AVG(p.ping_rttavg) AS ping_avg, AVG(p.ping_rttmax) AS ping_max, t.t_roundtrip, DATE(p.ping_date), DATE(t.t_date)
	FROM ping p JOIN topology t
	ON p.ip_addr = t.ip_addr AND DATE(p.ping_date) = DATE(t.t_date)
	WHERE p.ip_addr = cidr '""" + IPAdresa + """' AND p.ping_ploss >= 0 AND p.ping_ploss < 100 AND t.t_status = 'C'
	GROUP BY DATE(p.ping_date), DATE(t.t_date), t.t_roundtrip
	ORDER BY DATE(p.ping_date) ASC""")
pingMin = []
pingAvg = []
pingMax = []
roundtripResult = []
date = []
minRatio = []
avgRatio = []
maxRatio = []
for record in remCur:
	pingMin.append(record[0])
	pingAvg.append(record[1])
	pingMax.append(record[2])
	roundtripResult.append(float(record[3][-1]))
	date.append(record[4])
	minRatio.append(roundtripResult[-1] / pingMin[-1])
	avgRatio.append(roundtripResult[-1] / pingAvg[-1])
	maxRatio.append(roundtripResult[-1] / pingMax[-1])

plt.figure(figsize=(10, 6))
fig, ax1 = plt.subplots()
ax1.plot(date, minRatio, marker='o', linestyle='', color='r')

ax2 = ax1.twinx()
ax2.plot(date, avgRatio, marker='o', linestyle='', color='g')

ax3 = ax1.twinx()
ax3.plot(date, maxRatio, marker='o', linestyle='', color='b')

plt.title('Ratio of tracert and ping values over time for ' + IPAdresa)
plt.xlabel('Date')
plt.ylabel('Values')

min_y = min(min(minRatio), min(avgRatio), min(maxRatio))
max_y = max(max(minRatio), max(avgRatio), max(maxRatio))
ax1.set_ylim(min_y, max_y)
ax2.set_ylim(min_y, max_y)
ax3.set_ylim(min_y, max_y)

# Formatting x-axis with date
plt.gca().xaxis.set_major_formatter(mdates.DateFormatter('%Y-%m-%d'))
plt.gca().xaxis.set_major_locator(mdates.YearLocator())
plt.gcf().autofmt_xdate()
plt.show()
	
remCur.close()
remConn.close()
locCur.close()
locConn.close()
